! *******************************************************************
! * FILELENGTH ERMITTELT DIE LAENGE DES ANGEGEBENEN FILES UND GIBT  *
! *                           SIE ZURCK !                          *
! *      DIESE PROZEDUR FUNKTIONIERT FUER ALLE DATEIENTYPEN !       *
! *    !! DIESES INCLUDE-FILE IST NUR FUER DAS MODULE SYSTEM !!     *
! *!! FUER DEN HTTP-DAEMON IST DAS INCLUDE-FILE FILELENG.INC  !!    *
! *-----------------------------------------------------------------*
! * BENOETIGTE PROGRAMME / INCLUDE-FILES : FILEERR.INC              *
! *                                        NETLNK.SR                *
! *                                                                 *
! * BENOETIGTE VARIABLEN AUS DEM MODULE  : FILE2                    *
! *                                        NETST                    *
! *                                                                 *
! *-----------------------------------------------------------------*
! * ERSTELLT         : 05.05.1998                                   *
! * LETZTE AENDERUNG : 20.04.1999                                   *
! *******************************************************************
 FILELENGTH: PROC(FILENAME CHAR(255) IDENT,CONTENT_TYPE CHAR(255) IDENT,
                  METHOD_OR_ERROR CHAR(255) IDENT) RETURNS(FIXED(31));
    
    DCL FILESTATE            FIXED(15)    INIT(0);
    DCL LAENGE               FIXED(31)    INIT(0);
     
    OPEN FILE2 BY IDF(FILENAME),OLD;
    FILESTATE:=ST(FILE2);
    IF (FILESTATE NE 0) THEN
       #IF MINILOG+MAXILOG 
           PUT 'Ax: FILELENGTH : unable to opne file ',FILENAME
                TO LOGLINK BY A,A(LEN(FILENAME));
       #FIN; 
       PUT 'HTTP-User: FILELENGTH : KONNTE DATEI ',FILENAME,
           ' NICHT OEFFNEN !' TO 
           Alarm_out BY A,A(LEN(FILENAME)),A,SKIP;
    FIN;    
    
    IF (FILESTATE == 0) THEN

       APPEND(FILE2);
       SAVEP(FILE2,LAENGE);  

       CLOSE FILE2;
       FILESTATE:=ST(FILE2);
       IF (FILESTATE NE 0) THEN
          PUT 'FILELENGTH : KONNTE DATEI ',FILENAME,
              ' NICHT SCHLIESSEN !' TO 
              TERM BY A,A(LEN(FILENAME)),A,SKIP;
          PUT 'SYSTEM- FEHLER : ',FILESTATE TO TERM BY SKIP,A,F(3);
          FileErr(FILESTATE,TERM);
          #IF MAXILOG+MINILOG 
              PUT 'Ax: FILELENGTH : unable to close file ',FILENAME
                  TO LOGLINK  BY A,A(LEN(FILENAME));
              PUT 'Ax: File-error #',FILESTATE TO LOGLINK BY A,F(3);
              FileErr(FILESTATE,LOGLINK);
          #FIN; 
       FIN;   
    ELSE /* IF FILESTATE == 0 THEN */
       PUT 'FILELENGTH : KONNTE DATEI ',FILENAME,' NICHT OEFFNEN !'
           TO TERM BY A,A(LEN(FILENAME)),A,SKIP;
       PUT 'SYSTEM- FEHLER : ',FILESTATE TO TERM BY SKIP,A,F(3);
       FileErr(FILESTATE,TERM);
       #IF MAXILOG+MINILOG 
           PUT 'Ax: FILELENGTH : Unable to open file ',FILENAME
               TO LOGLINK BY A,A(LEN(FILENAME));
           PUT 'Ax: File-error #',FILESTATE TO LOGLINK BY A,F(3);
           FileErr(FILESTATE,LOGLINK);
       #FIN; 
    FIN; /* IF (FILESTATE == 0) THEN */

    #IF MAXILOG 
        PUT 'Ax: FILELENG : FILENAME : ',FILENAME TO 
            LOGLINK BY A,A(LEN(FILENAME));
        PUT 'Ax: FILESIZE            : ',LAENGE TO 
            LOGLINK BY A,F(10);
    #FIN; 

    RETURN(LAENGE);
 END; /*FILELENGTH*/
