! *******************************************************************
! * SEND_LISTE sends the list content to the client                 *
! *-----------------------------------------------------------------*
! * AUTOR : W. Gerth 23.04.2000                                     *
! *******************************************************************
SEND_LISTE : PROC(CHILD FIXED,ROOT REF LISTE); 

  DCL NETST             FIXED(15);
  DCL NETERROR          FIXED(15);
  DCL Bytes_to_go       FIXED(31);
  DCL Actblock   REF LISTE;       
  DCL Startadr REF CHAR(1);

   #IF MAXILOG 
     WRITE 'S: SEND_LISTE starting.' TO LOGLINK;       
   #FIN;

   Bytes_to_go = ROOT.Indexw;
   Actblock=ROOT;

! ... Due to a bug in the BSD-socket it is faster to use 512-blocks

   WHILE Actblock ISNT ROOT.Last REPEAT
     Startadr = Actblock.Array(0);
      TO 16 REPEAT
       NETST=NETLNK(CHILD,Startadr,BLOCKSIZE//16 FIT 1(15),SO_WRITE,
                    FLG_PUSH+FLG_WAIT);
       NETERROR=NETSTERR(NETST,'1'B,Alarm_out);
       IF NETERROR NE 0 THEN
          WRITE 'HTTP-USER: NETERROR in SENDLISTE WRITE BLOCKSIZE!'\0D0A\'' 
             TO Alarm_out;
          #IF MAXILOG+MINILOG 
            WRITE 'S: NETERROR in SENDLISTE WRITE BLOCKSIZE!'
               TO LOGLINK;
             NETERROR=NETSTERR(NETST,'1'B,LOGLINK);
          #FIN; 
       FIN; ! IF NETERROR NE 0 THEN !
       REFADD(Startadr,BLOCKSIZE//16);
      END;
     
     Bytes_to_go = Bytes_to_go-BLOCKSIZE;
     Actblock = Actblock.Next;
     END;

  ! ... Last we write the incomplete block ............................

   NETST=NETLNK(CHILD,Actblock.Array(0),Bytes_to_go FIT 1(15),SO_WRITE,
                FLG_PUSH+FLG_WAIT);
  
   NETERROR=NETSTERR(NETST,'1'B,Alarm_out);
   IF NETERROR NE 0 THEN
      WRITE 'HTTP-USER: NETERROR in SENDLISTE WRITE Rest!'\0D0A\'' 
         TO Alarm_out;
      #IF MAXILOG+MINILOG 
        WRITE 'S: NETERROR in SENDLISTE WRITE Rest!'
           TO LOGLINK;
         NETERROR=NETSTERR(NETST,'1'B,LOGLINK);
      #FIN; 
   FIN; ! IF NETERROR NE 0 THEN !



   #IF MAXILOG 
     PUT 'S: (SENDLIST) ',ROOT.Indexw,' bytes sent.' TO 
           LOGLINK BY A,F(10),A;       
     WRITE 'S: (SENDLIST) leaving. ' TO LOGLINK;       
   #FIN; 
 END; ! SEND_LISTE!  

